﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using DataDynamics.Reports;
using DataDynamics.Reports.ReportObjectModel;
using System.Web;
using System.IO;
namespace DDRCreatedRuntimeWithImages
{
    public class ReportCreator
    {
        private ReportDefinition _definition;
       
        public ReportDefinition Definition
          {
           get
              {
               if (_definition == null)
                  {
                    _definition = new ReportDefinition();
                    ConfigureLayout();
                    ConfigureDataSources();
                    ConfigureDataSets();
                    AddImages();
                  }
                   return _definition;
              }
          }

       

      private void ConfigureDataSets()
          {
           DataSet dataSet1 = new DataSet();
           dataSet1.Name = "DataSet1";
           dataSet1.Query.DataSourceName = "DataSource1";
           dataSet1.Fields.Add(new Field("Sales", "Sales",String.Empty));
          _definition.Report.DataSets.Add(dataSet1);
          }

     private void ConfigureDataSources()
         {
           DataSource dataSource1 = new DataSource();
           dataSource1.Name = "DataSource1";
           dataSource1.ConnectionProperties.DataProvider = "DATASET";
           _definition.Report.DataSources.Add(dataSource1);
         }

    private void ConfigureLayout()
        {
           Table _tbl = new Table();
          _tbl.Name = "Table1";
          _tbl.DataSetName = "DataSet1";
          _tbl.Left = "0in";
          _tbl.Top = "0in";
          _tbl.Width = "2in";
          _tbl.Height = "1in";
          
          TextBox textBox1 = new TextBox();
          textBox1.Name = "TextBox1";
          textBox1.Value = "=Fields!Sales.Value";
          textBox1.Left = "0in";
          textBox1.Top = "0in";
          textBox1.Width = "1in";
          textBox1.Height = "0.25in";
          
         TableColumn _column = new TableColumn();
         _column.Width = "1in";
         _tbl.TableColumns.Add(_column);

         TableColumn _column1 = new TableColumn();
         _column1.Width = "1in";
         _tbl.TableColumns.Add(_column1);
         
        TableRow _row = new TableRow();
        _row.Height = "1in";

        TableCell _cell = new TableCell();
        _cell.ReportItems.Add(textBox1);
        _row.TableCells.Add(_cell);
        _tbl.Details.TableRows.Add(_row);

        TableCell _cell1 = new TableCell();
        

        DataDynamics.Reports.ReportObjectModel.Image _img = new Image();
        _img.Name = "Myimage";
        _img.Source = DataDynamics.Reports.Extensibility.Rendering.Components.ImageSource.Embedded;
        _img.Value =@"=Switch( Fields!Sales.Value>5,""up"",Fields!Sales.Value<5,""down"")";
        _cell1.ReportItems.Add(_img);
        _row.TableCells.Add(_cell1);
        _definition.Report.Width = "6.5in";
        _definition.Report.Body.Height = "4in";
        _definition.Report.Body.ReportItems.Add(_tbl);
      }

    private void AddImages()
    {
        _definition.Report.EmbeddedImages.Add(GetImage("up.png"));
        _definition.Report.EmbeddedImages.Add(GetImage("down.png"));
        _definition.Report.EmbeddedImages.Add(GetImage("noChange.png"));
    }

    private EmbeddedImage GetImage(String Name)
    {
        using (System.Drawing.Image _img = System.Drawing.Image.FromFile(HttpContext.Current.Server.MapPath("~/"+Name)))
        {
            EmbeddedImage _image = new EmbeddedImage();
            _image.Name = Name.Replace(".png","");
            _image.MIMEType = "image/png";
             using (MemoryStream _ms = new MemoryStream())
            {
                _img.Save(_ms,System.Drawing.Imaging.ImageFormat.Png);
                _ms.Position = 0;
                byte[] imagedata = _ms.ToArray();
                _image.ImageData = Convert.ToBase64String(imagedata); 

            }
            return _image;
        }

    }

    }
   
}
